public interface iFuzzygroesse
{
      public abstract double berechneErfuelltheit(double x);
}


public class FuzzygroesseRechts  implements iFuzzygroesse
{
    private double s1,s2;
    
    public FuzzygroesseRechts(double s1, double s2)
    {
           this.s1 = s1;
           this.s2 = s2;
    }

    public double berechneErfuelltheit(double x)
    {
          if(x<s1)
             return 0.0;
          else if(x>s2)
             return 1.0;
          else
             return (x-s1)/(s2-s1);  
                       
    }
}


public class FuzzygroesseMitte implements iFuzzygroesse
{
    private double s1,s2,s3;
    
    public FuzzygroesseMitte(double s1, double s2, double s3)
    {
           this.s1 = s1;
           this.s2 = s2;
           this.s3 = s3;
    }

    public double berechneErfuelltheit(double x)
    {
           if(x<s1)                       
               return 0.0;
           else if(x<s2)
               return (x-s1)/(s2-s1);
           else if(x<s3)
               return 1.0 - (x-s2)/(s3-s2);
           else
               return 0.0;
    }
}


public class FuzzygroesseLinks implements iFuzzygroesse
{
    private double s1,s2;
    
    public FuzzygroesseLinks(double s1, double s2)
    {
           this.s1 = s1;
           this.s2 = s2;
    }

    public double berechneErfuelltheit(double x)
    {
          if(x<s1)
             return 1.0;
          else if(x>s2)
             return 0.0;
          else
             return 1.0-(x-s1)/(s2-s1);  // 1 -x/(s2-s1) + s1/(s2-s1)
             
          //  m = -1.0/(s2-s1)
          
          //  p1=[s1,1.0]
          //  p2=[s2,0.0]
          
          //  (y-y1)/(x-x1) = (y2-y1)/(x2-x1)
          
          //  (y-1) = (x-s1)*(-1)/(s2-s1)
          //   y    = 1 - (x-s1)/(s2-s1)
          
          
    }
}


public class Eingangsfuzzyset
{
      private iFuzzygroesse[] fuzzygroesse;
      private double[] erfuelltheit;
      
      public Eingangsfuzzyset(double[] s)
      {
           if(s==null || s.length<2)
           {
               System.out.println("ERROR in Eingangsfuzzyset: zu wenig Stuetzstellen!");
               return;
           }
          
           fuzzygroesse = new iFuzzygroesse[s.length];
           
           fuzzygroesse[0] = new FuzzygroesseLinks(s[0],s[1]);
           fuzzygroesse[fuzzygroesse.length-1] = new FuzzygroesseRechts(s[s.length-2],s[s.length-1]);
           
           for(int i=1;i<s.length-1;i++)
           {
                fuzzygroesse[i] = new FuzzygroesseMitte(s[i-1],s[i],s[i+1]);
           }
           
           erfuelltheit = new double[fuzzygroesse.length];
      }
      
      public double[] berechneErfuelltheit(double x)
      {
           for(int i=0;i<fuzzygroesse.length;i++)
               erfuelltheit[i] = fuzzygroesse[i].berechneErfuelltheit(x);
           return erfuelltheit;    
      }
}
