public class RuKuIntegrator implements iIntegrator
{
    iModell modell;

    private double[] y_neu;
    private double[] y_alt2;
    private double[] f_neu;
    
    private double[] k1,k2,k3,k4;
    
    public RuKuIntegrator()
    {
    }

    public double[] zeitschritt(double[] y_alt, double t, double dt)
    {
        f_neu = modell.berechneRechteSeite(y_alt,t);
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k1[i] = f_neu[i];
        }
        //k2: ----------------------------------------------------
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            y_alt2[i] = y_alt[i]+0.5*dt*k1[i];
        }

        f_neu = modell.berechneRechteSeite(y_alt2,t+0.5*dt);
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k2[i] = f_neu[i];
        }
        //k3: ----------------------------------------------------
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            y_alt2[i] = y_alt[i]+0.5*dt*k2[i];
        }

        f_neu = modell.berechneRechteSeite(y_alt2,t+0.5*dt);
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k3[i] = f_neu[i];
        }

        //k4: ----------------------------------------------------
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            y_alt2[i] = y_alt[i]+dt*k3[i];
        }

        f_neu = modell.berechneRechteSeite(y_alt2,t+dt);
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k4[i] = f_neu[i];
        }
        
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            y_neu[i] = y_alt[i] + (dt/6.0)*(k1[i]+2.0*k2[i]+2.0*k3[i]+k4[i]);
        }
        
        return y_neu;
    }
    public void registriereModell(iModell modell)
    {
        this.modell = modell;
        y_neu = new double[modell.holeAnzahlGleichungen()];
        y_alt2 = new double[modell.holeAnzahlGleichungen()];
        k1 = new double[modell.holeAnzahlGleichungen()];
        k2 = new double[modell.holeAnzahlGleichungen()];
        k3 = new double[modell.holeAnzahlGleichungen()];
        k4 = new double[modell.holeAnzahlGleichungen()];
        
    }
}
