iIntegrator integrator;
iModell     modell;

iIntegrator integratorEFS;
iModell     modellEFS;

Eingangsfuzzyset eingang_fuzzy_phi   = new Eingangsfuzzyset(new double[] {-1.0,1.0});
Eingangsfuzzyset eingang_fuzzy_omega = new Eingangsfuzzyset(new double[] {-1.0,1.0});


float gg = 9.81f;
float xA =  0.5f;
float xA_EFS =  0.5f;
float   h  = 1.0f;
float   hh = h*0.5f;
float   r = 0.04f;
float   m = 1.0f;
float   J = 0.25f*m*r*r + (1.0f/12.0f)*m*h*h;
float pixel_pro_meter = 200.0f;


float dt = 0.005f;
float  t = 0.0f;

float dt_EFS = 0.005f;
float  t_EFS = 0.0f;

//Zustandsgrößen:
float  x    = 0.0;
float phi   = 0.5f;
float vx    = 0.0;
float omega = 0.0f;
float  x_alt    = 0.0;
float phi_alt   = 0.5f;
float vx_alt    = 0.0;
float omega_alt = 0.0f;

float     F = 0.0f;

//Zustandsgrößen:
float  x_EFS    = 0.0;
float phi_EFS   = 0.5f;
float vx_EFS    = 0.0;
float omega_EFS = 0.0f;
float  x_alt_EFS    = 0.0;
float phi_alt_EFS   = 0.5f;
float vx_alt_EFS    = 0.0;
float omega_alt_EFS = 0.0f;

float     F_EFS = 0.0f;




float[][] punkte = {
                       {-r,0.0f}, //P1..P2 körpereigenes Koordinatensystem
                       { r,0.0f},
                       { r,h},
                       {-r,h}
                   };
float[][] punkte_trans = new float[4][2];

void transformieren(float[] quelle, float[] ziel, float xA, float phi)
{
     //  ziel = [xA,0] + T * quelle
     //T=
     //  cos(phi)  -sin(phi)
     //  sin(phi)   cos(phi)
     
     ziel[0] = xA   + quelle[0]*cos(phi) - quelle[1]*sin(phi);
     ziel[1] = 0.0f + quelle[0]*sin(phi) + quelle[1]*cos(phi);
}

float transFX(float x)
{
     return x*pixel_pro_meter+width/2;
}
float transFY(float y)
{
     return -y*pixel_pro_meter+height/2;
}

public void setup()
{
    modell     = new Einachser();
    integrator = new RuKuIntegrator();
    modellEFS     = new Einachser();
    integratorEFS = new RuKuIntegrator();
    integrator.registriereModell(modell);
    integratorEFS.registriereModell(modellEFS);
    size(800,600);
//    frameRate( 1.0f/dt );
    frameRate( 20);
}

public float berechneXA(float x, float phi)
{
    return x + 0.5f*h*sin(phi);
}

public void draw()
{

    double[] y_alt = {(double)x_alt,(double)vx_alt,(double)phi_alt,(double)omega_alt};
    //double[] y_neu =  y_alt;
    double[] y_neu = integrator.zeitschritt(y_alt,t,dt);
  
    double[] y_alt_EFS = {(double)x_alt_EFS,(double)vx_alt_EFS,
             (double)phi_alt_EFS,(double)omega_alt_EFS};
    //double[] y_neu_EFS = y_alt_EFS;
    double[] y_neu_EFS = integratorEFS.zeitschritt(y_alt_EFS,t,dt_EFS);
  
    //Eulerintegration der dynamischen Gleichungen:
    x     = (float)y_neu[0];
    vx    = (float)y_neu[1];
    phi   = (float)y_neu[2];
    omega = (float)y_neu[3]; 

    x_alt = x;
    vx_alt = vx;
    phi_alt = phi;
    omega_alt = omega;
    
    t+=dt;

    //***************                            
    
    x_EFS     = (float)y_neu_EFS[0];
    vx_EFS    = (float)y_neu_EFS[1];
    phi_EFS   = (float)y_neu_EFS[2];
    omega_EFS = (float)y_neu_EFS[3]; 

    x_alt_EFS = x_EFS;
    vx_alt_EFS = vx_EFS;
    phi_alt_EFS = phi_EFS;
    omega_alt_EFS = omega_EFS;
    
    t_EFS+=dt_EFS;                            
                            
                            
                            
    background(0);
    stroke(255);
 
    line(0,height/2,width,height/2);    
    xA = berechneXA(x,phi);
    xA_EFS = berechneXA(x_EFS,phi_EFS);
    float yA = 0.0f;
    float xB = xA - h*sin(phi);
    float yB =      h*cos(phi);

    float yA_EFS = 0.0f;
    float xB_EFS = xA_EFS - h*sin(phi_EFS);
    float yB_EFS =      h*cos(phi_EFS);
    
    
    line(transFX(xA),transFY(yA),transFX(xB),transFY(yB));
    fill(0,255,0);
    ellipse(transFX(xB_EFS),transFY(yB_EFS),5,5);

    for(int i=0;i<4;i++)
        transformieren(punkte[i],punkte_trans[i],xA,phi);
    stroke(255,0,0);    
    for(int i=0;i<4;i++)
    {
        line(transFX(punkte_trans[i][0]),transFY(punkte_trans[i][1]),
             transFX(punkte_trans[(i+1)%punkte_trans.length][0]),
             transFY(punkte_trans[(i+1)%punkte_trans.length][1]));        
    }
    
}
